import socket, random, struct
FCGI_HEADER_LEN=8
FCGI_VERSION_1=1
FCGI_BEGIN_REQUEST=1
FCGI_ABORT_REQUEST=2
FCGI_END_REQUEST=3
FCGI_PARAMS=4
FCGI_STDIN=5
FCGI_STDOUT=6
FCGI_STDERR=7
FCGI_DATA=8
FCGI_GET_VALUES=9
FCGI_GET_VALUES_RESULT=10
FCGI_UNKNOWN_TYPE=11
FCGI_MAXTYPE=FCGI_UNKNOWN_TYPE
FCGI_NULL_REQUEST_ID=0
FCGI_KEEP_CONN=1
FCGI_RESPONDER=1
FCGI_AUTHORIZER=2
FCGI_FILTER=3
data_max=32*1024
data_block=8192
class fastcgi:
    def __init__(self, endpoint, conn):
        self.endpoint=endpoint
        self.s=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.conn=conn
    def build_header(self, type, reqId, contentLen, paddingLen):
        return struct.pack('BBBBBBBB', FCGI_VERSION_1, type, reqId>>8, reqId&0xFF, 
                           contentLen>>8, contentLen&0xFF, paddingLen, 0)
    def add_param(self, params, name, value):
        lname=len(name)
        lval=len(value)
        if lname+lval+8+len(params)<data_max:
            if lname>0x80:
                params+=struct.pack('B', (lname>>24)|0x80)
                params+=struct.pack('B', (lname>>16)&0xFF)
                params+=struct.pack('B', (lname>>8)&0xFF)
                params+=struct.pack('B', lname&0xFF)
            else:
                params+=struct.pack('B', lname)
            if lval>0x80:
                params+=struct.pack('B', (lval>>24)|0x80)
                params+=struct.pack('B', (lval>>16)&0xFF)
                params+=struct.pack('B', (lval>>8)&0xFF)
                params+=struct.pack('B', lval&0xFF)
            else:
                params+=struct.pack('B', lval)
            params+=name+value
            return params
        else:
            print('!!!!')
    def do_post(self):
        postlen=int(self.conn.req['content-length'])
        sent=0
        
        while sent<postlen:
            read=0
            maxlength=min(postlen-sent, data_max)
            paddingLen=8-((maxlength-1) % 8 +1)
            #print(sent, read, maxlength, paddingLen)
            self.s.send(self.build_header(FCGI_STDIN, self.req_id, maxlength, paddingLen))
            #print('HEAD_OK')
            while read+data_block<maxlength:
                #print('_', read)
                self.s.send(self.conn.fd.recv(data_block))
                read+=data_block
                #print(read)
            else:
                #print('_0.0')
                rr=self.conn.fd.recv(maxlength-read)
                #print(repr(rr))
                self.s.send(rr)
                #print('0.0')
            self.s.send(struct.pack('B', 0)*paddingLen)
            sent+=maxlength
            #print(sent)
        self.s.send(self.build_header(FCGI_STDIN, self.req_id, 0, 0))
        #print('POST_OK')

    def rb(self):
        r=self.s.recv(1)
        if len(r)==0:
            raise Exception('Read null')
        r=struct.unpack('B', r)
        return r[0]
    def process(self):
        self.s.connect(self.endpoint)
        self.req_id=random.randint(0, 65536)
        header=self.build_header(FCGI_BEGIN_REQUEST, self.req_id, 8, 0)
        body=struct.pack('BB', 0, FCGI_RESPONDER)+struct.pack('B', 0)*6
        self.s.send(header+body)
        #s.send(body)
        params=''
        params=self.add_param(params, 'SCRIPT_FILENAME', self.conn.req_path)
        params=self.add_param(params, 'QUERY_STRING', self.conn.querystring)
        params=self.add_param(params, 'REQUEST_METHOD', self.conn.method)
        params=self.add_param(params, 'SCRIPT_NAME', self.conn.script_name)
        params=self.add_param(params, 'REQUEST_URI', self.conn.uri)
        params=self.add_param(params, 'DOCUMENT_URI', self.conn.uri)
        params=self.add_param(params, 'DOCUMENT_ROOT', self.conn.root)
        params=self.add_param(params, 'SERVER_PROTOCOL', self.conn.httpver)
        params=self.add_param(params, 'SERVER_SOFTWARE', 'WDServer')
        params=self.add_param(params, 'GATEWAY_INTERFACE', 'CGI/1.1')
        params=self.add_param(params, 'REMOTE_ADDR', self.conn.addr[0])
        params=self.add_param(params, 'SERVER_ADDR', self.conn.serv_addr)
        params=self.add_param(params, 'SERVER_PORT', str(self.conn.serv_port))
        params=self.add_param(params, 'SERVER_NAME', self.conn.server_name)
        params=self.add_param(params, 'REDIRECT_STATUS', '200')
        if 'content-type' in self.conn.req:
            params=self.add_param(params, 'CONTENT_TYPE', self.conn.req['content-type'])
        if 'content-length' in self.conn.req:
            params=self.add_param(params, 'CONTENT_LENGTH', self.conn.req['content-length'])
        if 'accept' in self.conn.req:
            params=self.add_param(params, 'HTTP_ACCEPT', self.conn.req['accept'])
        if 'accept-language' in self.conn.req:
            params=self.add_param(params, 'HTTP_ACCEPT_LANGUAGE', self.conn.req['accept-language'])
        if 'accept-encoding' in self.conn.req:
            params=self.add_param(params, 'HTTP_ACCEPT_ENCODING', self.conn.req['accept-encoding'])
        if 'user-agent' in self.conn.req:
            params=self.add_param(params, 'HTTP_USER_AGENT', self.conn.req['user-agent'])
        if 'host' in self.conn.req:
            params=self.add_param(params, 'HTTP_HOST', self.conn.req['host'])
        if 'connection' in self.conn.req:
            params=self.add_param(params, 'HTTP_CONNECTION', self.conn.req['connection'])
        if 'cache-control' in self.conn.req:
            params=self.add_param(params, 'HTTP_CACHE_CONTROL', self.conn.req['cache-control'])
        if 'cookie' in self.conn.req:
            params=self.add_param(params, 'HTTP_COOKIE', self.conn.req['cookie'])
        if 'referer' in self.conn.req:
            params=self.add_param(params, 'HTTP_REFERER', self.conn.req['referer'])
        #etc param
        paramsLen=len(params)
        paddingLen=8-((paramsLen-1) % 8 +1)
        params+=struct.pack('B', 0)*paddingLen
        header=self.build_header(FCGI_PARAMS, self.req_id, paramsLen, paddingLen)
        self.s.send(header)
        self.s.send(params)
        self.s.send(self.build_header(FCGI_PARAMS, self.req_id, 0, 0))
        if self.conn.method=='POST':
            self.do_post()
        #fo=open('ret.html', 'w')
        
        code=200
        des='OK'
        err=''
        
        isHead=True
        #fd=self.s.makefile()
        while True:
            try: 
                r_ver=self.rb()
                r_type=self.rb()
                r_id=self.rb()<<8
                r_id+=self.rb()
                r_len=self.rb()<<8
                r_len+=self.rb()
                r_padding=self.rb()
                r_re=self.rb()
            except:
                break
            #print(r_len, r_padding)
            if r_len==0 and r_padding==0:
                continue
            if r_type==FCGI_STDOUT:
                sread=0
                if isHead:
                    while True:
                        r=''
                        while sread<r_len and r.find('\r\n')<0:
                            r+=struct.unpack('c', self.s.recv(1))[0]
                            sread+=1
                        r=r.replace('\r', '')
                        r=r.replace('\n', '')
                        if r=='':
                            #print(repr(r))
                            self.conn.sendresponse(self.conn.res, code, des)
                            isHead=False
                            break
                        #r=fd.readline()
                        #sread+=len(r)

                        r=r.split(':', 1)
                        #print(r)
                        t=r[0]
                        v=r[1].strip()
                        if t=='PHP Fatal error' or t=='PHP Notice':
                            err+=t + ': ' + v + '\r\n'
                            #self.conn.fd.send(v)
                        elif t=='Status':
                            v=v.split(' ', 1)
                            code=int(v[0])
                            des=v[1]
                        else:
                            if t in self.conn.res:
                                self.conn.res[t]+='\n' + t + ': ' + v
                            else:
                                self.conn.res[t]=v
                        #print(repr(r))
                        if sread>=r_len:
                            break
                if not isHead:
                    #print(sread, r_len)
                    while sread+data_block<r_len:
                        self.conn.fd.send(self.s.recv(data_block))
                        sread+=data_block
                    else:
                        self.conn.fd.send(self.s.recv(r_len-sread))
                if r_padding>0:
                    self.s.recv(r_padding) #Eat it!
                if err!='':
                    self.conn.fd.send(err)
            elif r_type==FCGI_END_REQUEST:
                rr=self.s.recv(8)
                return 
            #fo.close()
        
def main():
    fcgi=fastcgi(('127.0.0.1', 9000), None)
    fcgi.process()
if __name__=='__main__':
    main()
